<script type="ts">
    // This component sets up the navigation bar with buttons to hide/unhide the
    // edit / bookmark sidebar, an indicator of open queries, the info button
    // and the title of the web app
    import {
        show_info,
        left_pane_api,
        left_pane_collapsed,
    } from "./svelte_stores/show_panes_store.js";
    import {
        Bars3,
        Server,
        DocumentArrowDown,
        InformationCircle,
        Sun,
        Moon,
    } from "svelte-heros-v2";
    import { Button, ButtonGroup, Indicator, DarkMode } from "flowbite-svelte";
    import { useIsFetching } from "@sveltestack/svelte-query";
    import { layout } from "./svelte_stores/layout_store";
    import { innerWidth } from "./svelte_stores/sidebar_width_store.js";

    const isFetching = useIsFetching();

    const left_pane_size = function (innerWidth) {
        let size;
        if (innerWidth < 800) {
            size = 100;
        } else {
            size = 100 * (500 / innerWidth);
        }
        // console.log("Computed size: ", size);
        return size;
    };

    // The left pane starts out collapsed.
    // When the button is toggled the first time, it will calculate
    // a reasonable size for the left pane.

    const toggle_left_pane = function () {
        if ($left_pane_api.isCollapsed()) {
            // console.log("getSize: ", $left_pane_api.getSize());
            if ($left_pane_collapsed) {
                $left_pane_api.resize(left_pane_size($innerWidth));
                $left_pane_collapsed = false;
            }
            $left_pane_api.expand();
        } else {
            $left_pane_api.collapse();
        }
    };

    function downloadSVG() {
        const svg = document.getElementById("svg_image").outerHTML;
        const blob = new Blob([svg.toString()]);
        const element = document.createElement("a");
        element.download = "timeline_viewer_vector_graphic.svg";
        element.href = window.URL.createObjectURL(blob);
        element.click();
        element.remove();
    }
</script>

<div class="p-2 flex flex-row justify-between items-center">
    <div class="flex flex-row items-center">
        <div class="space-x-2">
            <ButtonGroup>
                <Button
                    class="p-2"
                    on:click={toggle_left_pane}
                    title="Show controls">
                    <Bars3 size="18" />
                </Button>
                {#if $isFetching}
                    <Button
                        title="Open query indicator"
                        class="p-2 relative"
                        on:click={() => {}}>
                        <Server size="18" />
                        <Indicator
                            placement="top-right"
                            border
                            size="xl"
                            class="text-xs dark:text-black"
                            >{$isFetching}</Indicator>
                    </Button>
                {:else}
                    <Button class="p-2" on:click={() => {}}>
                        <Server size="18" />
                    </Button>
                {/if}
            </ButtonGroup>
        </div>
        <span class="ml-4 whitespace-nowrap">
            {#if "title" in $layout}
                <span class="text-2xl font-normal dark:text-white">
                    {$layout.title}
                </span>
                {#if "subtitle" in $layout}
                    <span class="text-2xl font-thin dark:text-white">
                        {$layout.subtitle}
                    </span>
                {/if}
            {:else}
                <span class="text-2xl font-normal dark:text-white">
                    Space Weather
                </span>
                <span class="text-2xl font-thin dark:text-white">
                    Timeline Viewer
                </span>
            {/if}
        </span>
    </div>
    <div>
        <ButtonGroup>
            <Button
                title="Show info"
                pill={false}
                class="p-2 relative"
                on:click={() => {
                    $show_info = !$show_info;
                }}>
                <InformationCircle size="18" />
            </Button>
            <Button
                title="Download SVG"
                class="p-2"
                on:click={() => {
                    downloadSVG();
                }}><DocumentArrowDown size="18" /></Button>
            <DarkMode
                class="p-2"
                size="md"
                btnClass="text-gray-500 dark:text-gray-400 bg-gray-100 dark:bg-gray-700 hover:bg-gray-200  dark:hover:bg-gray-600 focus:outline-none rounded-e-md text-sm p-2.5"
                pill="false">
                <Sun size="18" slot="lightIcon" color="white" />
                <Moon size="18" slot="darkIcon" color="black" />
            </DarkMode>
        </ButtonGroup>
    </div>
</div>
